#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
   key_t mkey;
   int size;
   int mid; 
   int id;
   char *datap;
   
   if(argc<3)
   {
       printf("usage: %s sm_file id\n",argv[0]);
       exit(1);
   }
      
   mkey=ftok(argv[1],'X');
   if(-1==mkey)
   {
       perror("ftok"); exit(1);
   }       
   id=atoi(argv[2]);
          
   mid=shmget(mkey,20,0666);   /*open shared memory*/
   if(-1==mid)
   { 
       perror("shmget"); exit(2);
   }
   
   datap=shmat(mid,0,0); //attach memory
   
   if(((char*)-1)==datap)
   {
     perror("shmat");exit(3);  
   }
   
   do
   {
   //child 1
       switch(id)
       {
           case 1:
                printf("%d %d\n",getpid(),(unsigned char)datap[10]); /*printing value*/
                usleep(100);  
                break;
           case 2:
                datap[10]++;
                usleep(230);
                break;
           default://unknown id
               return -1;
       }
   }while(datap[12]!=11);
   
   if(0!=shmdt(datap))
   {
       perror("shmdt");exit(1);
   }

   
   printf("exit %d\n",getpid());
   return 0;
}