#include <windows.h>
#include <stdio.h>
#define S_1K 1024

void printErrorAndExit(const char *msg, DWORD err)
{
	LPSTR lpMsgBuf;
	if(FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|
			          FORMAT_MESSAGE_FROM_SYSTEM | 
					  FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						err,
					  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
					  (LPTSTR) &lpMsgBuf,
					  0,
					  NULL ))
	{
		fprintf(stderr,"%s : %s\n",msg,lpMsgBuf);
		LocalFree(lpMsgBuf);
	}
	else
	{
		fprintf(stderr,"Error at FormatMesage: %d\n",err=GetLastError());
	}
	exit(err);
}

int main(int argc, char *argv[])
{
    LPVOID ptr;
    int *iptr=NULL;
    int size=0;
    char c;int *t;
    SIZE_T lmin,lmax;
    int len;
    HANDLE hStdout;
    CONSOLE_SCREEN_BUFFER_INFO binfo;
    COORD pos;
    
    if(INVALID_HANDLE_VALUE==(hStdout=GetStdHandle(STD_OUTPUT_HANDLE)))
       printErrorAndExit("GetStdHandle",GetLastError());
    
    if(argc<2)
        len=1;
    else
        len=atoi(argv[1]);
    
    printf("Using %d kB Blocks\n\n",len);
       
    printf("(r)eserve  (c)omitt (m)alloc (q)quit\naction: ");
    
    if(!GetConsoleScreenBufferInfo(hStdout,&binfo))
        printErrorAndExit("GetConsoleScreenBufferInfo",GetLastError());
    
    pos.X=binfo.dwCursorPosition.X;
    pos.Y=binfo.dwCursorPosition.Y;    
    
    while('q'!=(c=getch()))
    {
        
	
	   if(!SetConsoleCursorPosition(hStdout,pos))
            printErrorAndExit("SetConsoleCursorPosition",GetLastError());
       
       printf("%c",c);
        
       switch(c)
       {
          case 'm':
            if(NULL==(iptr=realloc(iptr,size+S_1K*len)))
            {
                perror("malloc\n");
                return 2;
            }
            size+=S_1K*len;
            break;
          case 'r':
            if(NULL==(ptr=VirtualAlloc(NULL,S_1K*len,MEM_RESERVE,PAGE_READWRITE)))
                printErrorAndExit("VirtualAlloc RESERVE",GetLastError());
            break;
          case 'c':
            if(NULL==VirtualAlloc(ptr,S_1K*len,MEM_COMMIT,PAGE_READWRITE))
                printErrorAndExit("VirtualAlloc COMMIT",GetLastError());
        }
	    
    }
    free(iptr);
    VirtualFree(ptr,0,MEM_RELEASE);
    return 0;
}